#ifndef SHTEJ_H
#define SHTEJ_H

#define BINFILE_DIR "/usr/local/ASTBin"

//#define ECHO_ALWAYS_OPEN
#define INTR_TYPE_NONE                  0              // Interrupt identifiers
#define INTR_TYPE_LOCAL_1               (1 << 0)
#define INTR_TYPE_LOCAL_2               (1 << 1)
#define INTR_TYPE_PCI_ABORT             (1 << 2)
#define INTR_TYPE_DOORBELL              (1 << 3)
#define INTR_TYPE_OUTBOUND_POST         (1 << 4)
#define INTR_TYPE_DMA_0                 (1 << 5)
#define INTR_TYPE_DMA_1                 (1 << 6)
#define INTR_TYPE_DMA_2                 (1 << 7)
#define INTR_TYPE_DMA_3                 (1 << 8)
#define INTR_TYPE_SOFTWARE              (1 << 9)

#define PCI9054_DMA0_MODE		0x80
#define PCI9054_DMA1_MODE		0x94
#define PCI9054_OUTPOST_INT_STAT	0x30
#define PCI9054_OUTPOST_INT_MASK	0x34
#define PCI9054_INT_CTRL_STAT		0x68
#define PCI9054_FIFO_CTRL_STAT		0xe8
#define PCI9054_EEPROM_CTRL_STAT	0x6c
#define PCI9054_LOCAL_DMA_ARBIT		0x08
#define PCI9054_DMA_THRESHOLD		0xb0
#define PCI9054_DMA_COMMAND_STAT	0xa8

#define PCI9054_DMA0_PCI_DAC 		0xb4
#define PCI9054_DMA0_DESC_PTR		0x90
#define PCI9054_DMA0_PCIADDR		0x84
#define PCI9054_DMA0_LOCADDR		0x88
#define PCI9054_DMA0_SIZE		0x8c

#define PCI9054_DMA1_PCI_DAC 		0xb8
#define PCI9054_DMA1_DESC_PTR		0xa4
#define PCI9054_DMA1_PCIADDR		0x98
#define PCI9054_DMA1_LOCADDR		0x9c
#define PCI9054_DMA1_SIZE		0xa0


#define GENERIC_OK			0x0000
#define GENERIC_ERROR			0xFFFF

#define DMA_WRITE_ERROR			0xFF01
#define DMA_READ_ERROR			0xFF02
#define DMA_WNR_ERROR			0xFF03 //DMA write and read inconstant

//MT90866 ERROR
#define MT90866_WNR_ERROR		0xFF10 //MT90866 write and read inconstant
#define CHANNRL_LINK_ERROR		0xFF11

//DSP ERROR 
#define DSP_SELECT_ERROR		0xFF20
#define LOADER_MODE_ERROR		0xFF21
#define DSP_WNR_ERROR			0xFF22 //DSP write and read inconstant
#define BF561_SELECT_ERROR		0xFF23
//FILE OPERATION ERROR
#define FILE_OPEN_ERROR			0xFF30
#define FILE_CORRUPT_ERROR		0xFF31
#define FILE_POINT_ERROR		0xFF32
#define MEMORY_MALLOC_ERROR		0xFF33
#define FILE_READ_ERROR			0xFF34
#define FILE_BLOCK_SIZE_ERROR		0xFF35
#define FILE_LENGTH_ERROR		0xFF36
#define FILE_CRC_ERROR			0xFF37

//DS26524 ERROR
#define DS26524_WRITE_ERROR		0xFF40
#define DS26524_READ_ERROR		0xFF41
#define DS26524_DEVICE_ERROR		0xFF42 //DS26524 
#define DS26524_WNR_ERROR		0xFF43 //DS26524 write and read inconstant

//define card information address
#define    CARD_TYPE_ADDR			   0x10
#define    CARD_USER_ID_ADDR		   0x12
#define    CARD_CPLD_VER_ADDR		   0x14

#define		MEM_BASE_ADDR1			0xd900  //PCR 18h of card 1
#define		MEM_BASE_ADDR2			0xd940	//PCR 18h of card 2
#define		REG_BASE_ADDR1			0xd920  //PCR 10h of card 1
#define		REG_BASE_ADDR2			0xd960	//PCR 10h of card 2
#define		DSP_RESET			0x0020  //DSP reset address
#define		BLACKFIN_SELECT		0x0000	//Blackfin selcet address
#define		BLACKFIN_RESET		0x0002	//Blackfin reset address
#define		BLACKFIN_INT		0X0004	//Blackfin interrupt address
#define		SPI_STATE_REG		0X0008	//SPI state register address
#define		MT90866_RESET		0X0022	//MT90866 reset address
#define		CT_END				0X28	//CT-BUS end selcet address
#define		MT_ODE				0x2a	//MT90866 output enable address
#define		DSP_REG_CONTROL		0X40	//DPS register control address
//DS26524
#define		DS528_Addr			0x00
#define		DS528A_Data			0x06
#define		DS528B_Data			0x0c

#define MAX_DSP_NUMBER		1
#define MAX_LOCAL_STREAM	19

#define	 BUFLEN			0x60//0x180
#define	 PLAYBUFPRM		0x3f50
#define	 PLAYBUFLEN		0xc10	//3088
#define	 MAXFRAMES		32
#define	 QCMDLEN		0x100	//256
#define	 RECBUFPRM		0x0c3c
#define	 RECBUFLEN		0x3311	//13073

#define BASEADDR_PLAYBUF		0x1680
#define PLAYBUF_FLAG			0x1E84
#define BASEADDR_RECBUF			0x1F00
#define RECBUF_FLAG			0x2704

#define PLAYBLOCK_LEN				513
#define PLAYBLOCK_NUM				4
#define RECBLOCK_LEN				513
#define RECBLOCK_NUM				4
//#define	RECDATA_NUM					1

#define PLAYBLOCK_BUF				8
#define PLAYLIMIT_BUF				5
#define RECBLOCK_BUF				8
#define RECLIMIT_BUF				5

#define MAXDSPUSED		5
#define	VOCDSP			5
#define MAXECDSPUSED		4
#define NUM_CARDS		128

struct tej_regs
{
	unsigned short reg;
};
#define TEJ_SET_RBSREGS   _IOW (ZT_CODE, 80, struct tej_regs)

struct dspbindata {
	char name[256];
	void *dsp_data;
};

typedef struct binheader {
	unsigned short bin_type;
	unsigned short start_addr;
	unsigned short block_num;
	unsigned short data[0];
}binheader;

typedef struct binblock {
	unsigned short block_addr;
	unsigned short block_size;
	unsigned short data[0];
}binblock;

struct plx_reg_data {
	struct shtej *wc;
	unsigned long offset;
	unsigned long bitstoset;
	unsigned long bitstoclear;
};

typedef enum  _DMA_CHANNEL {
	DMA_CHANNEL0,
	DMA_CHANNEL1,
} DMA_CHANNEL;

typedef enum  _DMA_STATE {
	DMA_STATE_CLOSED,
	DMA_STATE_BLOCK,
	DMA_STATE_SGL,
} DMA_STATE;

typedef enum _DMA_CHANNEL_PRIORITY {
	CHANNEL_0_HIGHEST,
	CHANNEL_1_HIGHEST,
	CHANNEL_2_HIGHEST,
	CHANNEL_3_HIGHEST,
	ROTATIONAL,
} DMA_CHANNEL_PRIORITY;

struct dma_channel_desc {
	unsigned int enablereadyinput	:1;
	unsigned int enablebterminput	:1;
	unsigned int enableiopburst	:1;
	unsigned int enablewriteinvalidmode	:1;
	unsigned int enabledmaeoppin	:1;
	unsigned int dmastoptransfermode:1;
	unsigned int holdiopaddrconst	:1;
	unsigned int demandmode		:1;
	unsigned int enabletransferconutclear	:1;
	unsigned int waitstates		:4;
	unsigned int iopbuswidth	:2;
	unsigned int eotendlink		:1;
	unsigned int validstopcontrol	:1;
	unsigned int validmodeenable	:1;
	unsigned int enabledualaddresscycles:1;
	unsigned int tholdforiopwrites	:4;
	unsigned int tholdforiopreads	:4;
	unsigned int tholdforpciwrites	:4;
	unsigned int tholdforpcireads	:4;
	DMA_CHANNEL_PRIORITY dmachannelpriority;
};

struct plx_phys_mem_object {
	struct list_head listentry;
	void *owner;
	void *kernelva;
	u64 cpuphysical;
	u64 busphysical;
	u32 size;
};

struct dma_transfer_element {
	union {
		u64 userva;
		u32 pciaddrlow;
	} u;
	u32 pciaddrhigh;
	u32 localaddr;
	u32 transfercount;
	u32 terminalcountintr :1;
	u32 localtopcidma :1;
};

struct dma_channel_info {
	DMA_STATE state;
	void *owner;
	unsigned char localaddrconstant;
	u32 numpages;
	u32 initialoffset;
	u32 buffersize;
	int direction;
	struct page **pagelist;
	struct plx_phys_mem_object sglbuffer;
	struct plx_phys_mem_object dspbuffer;
	struct dma_transfer_element dmadata[600];
	u32	dmadatacount;
	u32	timeout;
};

struct dsp_writechunk_frame {
	unsigned short writeflag;
	unsigned char  writechunkbuf[0];
};
struct dsp_readchunk_frame {
	unsigned short readflag;
	unsigned char  readchunkbuf[0];
};

struct shtej_desc {
	char *name;
	int flags;
};

struct shtej_span;

struct shtej {
	/* This structure exists one per card */
	struct pci_dev *dev;		/* Pointer to PCI device */
	unsigned int intcount;
	int num;			/* Which card we are */
	int globalconfig;		/* Whether global setup has been done */
	int syncsrc;			/* active sync source */
	int numspans;
	int irq_enable;
	unsigned long interruptsrc;
	int MaxSpans;
	int InitCard;
	int t1e1;
	u32 serialno;
	int tflags;
	
	unsigned short RECFlag;
	unsigned short TRIFlag;
	int RECFlag_First;
	int TRIFlag_First;

	int irq;
	struct shtej_span *tspans[4];
	int freeregion_plx;
	int freeregion_dsp;
	spinlock_t lock;
	char *variety;
	unsigned long plx_region;
	unsigned long plx_len;
	volatile void *plx;
	unsigned long dsp_region;
	unsigned long dsp_len;
	volatile void *dsp;
	unsigned long dsp_addr;
	int cardtype;

	struct dsp_readchunk_frame *readchunk_frame[RECBLOCK_BUF];
	struct dsp_writechunk_frame *writechunk_frame[PLAYBLOCK_BUF];
	//unsigned char *readchunk[RECBLOCK_BUF][RECDATA_NUM][NUM_CARDS];
	unsigned char *readchunk[RECBLOCK_BUF][NUM_CARDS];
	unsigned char *writechunk[PLAYBLOCK_BUF][NUM_CARDS];

	int readcurpos;
	int readfillpos;
	int rpos;
	int readhasdata[RECBLOCK_BUF];
	int writecurpos;
	int writefillpos;
	int writehasdata[PLAYBLOCK_BUF];
	
	struct dma_channel_info dmainfo[2];
	
	wait_queue_head_t rec_span_q;
	struct workqueue_struct *rec_span_wq;
	struct work_struct rec_span_work;
	
	/*dsp voice debug*/
	int complete;
	int Index;
	int filecount;
	unsigned char * tmpwriterec[2][31];
	unsigned char * tmpwrite[2][31];
	wait_queue_head_t regq;
	struct workqueue_struct *shtej_wq;
	struct work_struct shtej_work;
	
	int BTime;
	struct timeval stime, etime, qtime;
	
	//add TEJ timer sync,09/03/30
  int	checktiming;
	//end

};

struct shtej_span {
	struct shtej *owner;
	int spantype;
	int sync;
	int psync;
	int syncpos;
	int spanflags;
	int alarmtimer;
	int index;
	u32 echocan;
	u32 alarm;
	unsigned char sigset;
	unsigned char doecho;
	unsigned char txsigs[16];
	unsigned char dorbs[16];
	
	struct zt_span span;
	struct zt_chan chans[0];
};

#endif
